// Generated by Snowball 2.1.0 - https://snowballstem.org/

#pragma warning disable 0164
#pragma warning disable 0162

namespace Snowball
{
    using System;
    using System.Text;
    
    ///<summary>
    ///  This class implements the stemming algorithm defined by a snowball script.
    ///  Generated by Snowball 2.1.0 - https://snowballstem.org/
    ///</summary>
    /// 
    [System.CodeDom.Compiler.GeneratedCode("Snowball", "2.1.0")]
    public partial class PortugueseStemmer : Stemmer
    {
        private int I_p2;
        private int I_p1;
        private int I_pV;

        private static string g_v = "aeiou\u00E1\u00E9\u00ED\u00F3\u00FA\u00E2\u00EA\u00F4";
        private readonly Among[] a_0;
        private readonly Among[] a_1;
        private readonly Among[] a_2;
        private readonly Among[] a_3;
        private readonly Among[] a_4;
        private readonly Among[] a_5;
        private readonly Among[] a_6;
        private readonly Among[] a_7;
        private readonly Among[] a_8;

        /// <summary>
        ///   Initializes a new instance of the <see cref="PortugueseStemmer"/> class.
        /// </summary>
        /// 
        public PortugueseStemmer()
        {
            a_0 = new[] 
            {
                new Among("", -1, 3),
                new Among("\u00E3", 0, 1),
                new Among("\u00F5", 0, 2)
            };

            a_1 = new[] 
            {
                new Among("", -1, 3),
                new Among("a~", 0, 1),
                new Among("o~", 0, 2)
            };

            a_2 = new[] 
            {
                new Among("ic", -1, -1),
                new Among("ad", -1, -1),
                new Among("os", -1, -1),
                new Among("iv", -1, 1)
            };

            a_3 = new[] 
            {
                new Among("ante", -1, 1),
                new Among("avel", -1, 1),
                new Among("\u00EDvel", -1, 1)
            };

            a_4 = new[] 
            {
                new Among("ic", -1, 1),
                new Among("abil", -1, 1),
                new Among("iv", -1, 1)
            };

            a_5 = new[] 
            {
                new Among("ica", -1, 1),
                new Among("\u00E2ncia", -1, 1),
                new Among("\u00EAncia", -1, 4),
                new Among("logia", -1, 2),
                new Among("ira", -1, 9),
                new Among("adora", -1, 1),
                new Among("osa", -1, 1),
                new Among("ista", -1, 1),
                new Among("iva", -1, 8),
                new Among("eza", -1, 1),
                new Among("idade", -1, 7),
                new Among("ante", -1, 1),
                new Among("mente", -1, 6),
                new Among("amente", 12, 5),
                new Among("\u00E1vel", -1, 1),
                new Among("\u00EDvel", -1, 1),
                new Among("ico", -1, 1),
                new Among("ismo", -1, 1),
                new Among("oso", -1, 1),
                new Among("amento", -1, 1),
                new Among("imento", -1, 1),
                new Among("ivo", -1, 8),
                new Among("a\u00E7a~o", -1, 1),
                new Among("u\u00E7a~o", -1, 3),
                new Among("ador", -1, 1),
                new Among("icas", -1, 1),
                new Among("\u00EAncias", -1, 4),
                new Among("logias", -1, 2),
                new Among("iras", -1, 9),
                new Among("adoras", -1, 1),
                new Among("osas", -1, 1),
                new Among("istas", -1, 1),
                new Among("ivas", -1, 8),
                new Among("ezas", -1, 1),
                new Among("idades", -1, 7),
                new Among("adores", -1, 1),
                new Among("antes", -1, 1),
                new Among("a\u00E7o~es", -1, 1),
                new Among("u\u00E7o~es", -1, 3),
                new Among("icos", -1, 1),
                new Among("ismos", -1, 1),
                new Among("osos", -1, 1),
                new Among("amentos", -1, 1),
                new Among("imentos", -1, 1),
                new Among("ivos", -1, 8)
            };

            a_6 = new[] 
            {
                new Among("ada", -1, 1),
                new Among("ida", -1, 1),
                new Among("ia", -1, 1),
                new Among("aria", 2, 1),
                new Among("eria", 2, 1),
                new Among("iria", 2, 1),
                new Among("ara", -1, 1),
                new Among("era", -1, 1),
                new Among("ira", -1, 1),
                new Among("ava", -1, 1),
                new Among("asse", -1, 1),
                new Among("esse", -1, 1),
                new Among("isse", -1, 1),
                new Among("aste", -1, 1),
                new Among("este", -1, 1),
                new Among("iste", -1, 1),
                new Among("ei", -1, 1),
                new Among("arei", 16, 1),
                new Among("erei", 16, 1),
                new Among("irei", 16, 1),
                new Among("am", -1, 1),
                new Among("iam", 20, 1),
                new Among("ariam", 21, 1),
                new Among("eriam", 21, 1),
                new Among("iriam", 21, 1),
                new Among("aram", 20, 1),
                new Among("eram", 20, 1),
                new Among("iram", 20, 1),
                new Among("avam", 20, 1),
                new Among("em", -1, 1),
                new Among("arem", 29, 1),
                new Among("erem", 29, 1),
                new Among("irem", 29, 1),
                new Among("assem", 29, 1),
                new Among("essem", 29, 1),
                new Among("issem", 29, 1),
                new Among("ado", -1, 1),
                new Among("ido", -1, 1),
                new Among("ando", -1, 1),
                new Among("endo", -1, 1),
                new Among("indo", -1, 1),
                new Among("ara~o", -1, 1),
                new Among("era~o", -1, 1),
                new Among("ira~o", -1, 1),
                new Among("ar", -1, 1),
                new Among("er", -1, 1),
                new Among("ir", -1, 1),
                new Among("as", -1, 1),
                new Among("adas", 47, 1),
                new Among("idas", 47, 1),
                new Among("ias", 47, 1),
                new Among("arias", 50, 1),
                new Among("erias", 50, 1),
                new Among("irias", 50, 1),
                new Among("aras", 47, 1),
                new Among("eras", 47, 1),
                new Among("iras", 47, 1),
                new Among("avas", 47, 1),
                new Among("es", -1, 1),
                new Among("ardes", 58, 1),
                new Among("erdes", 58, 1),
                new Among("irdes", 58, 1),
                new Among("ares", 58, 1),
                new Among("eres", 58, 1),
                new Among("ires", 58, 1),
                new Among("asses", 58, 1),
                new Among("esses", 58, 1),
                new Among("isses", 58, 1),
                new Among("astes", 58, 1),
                new Among("estes", 58, 1),
                new Among("istes", 58, 1),
                new Among("is", -1, 1),
                new Among("ais", 71, 1),
                new Among("eis", 71, 1),
                new Among("areis", 73, 1),
                new Among("ereis", 73, 1),
                new Among("ireis", 73, 1),
                new Among("\u00E1reis", 73, 1),
                new Among("\u00E9reis", 73, 1),
                new Among("\u00EDreis", 73, 1),
                new Among("\u00E1sseis", 73, 1),
                new Among("\u00E9sseis", 73, 1),
                new Among("\u00EDsseis", 73, 1),
                new Among("\u00E1veis", 73, 1),
                new Among("\u00EDeis", 73, 1),
                new Among("ar\u00EDeis", 84, 1),
                new Among("er\u00EDeis", 84, 1),
                new Among("ir\u00EDeis", 84, 1),
                new Among("ados", -1, 1),
                new Among("idos", -1, 1),
                new Among("amos", -1, 1),
                new Among("\u00E1ramos", 90, 1),
                new Among("\u00E9ramos", 90, 1),
                new Among("\u00EDramos", 90, 1),
                new Among("\u00E1vamos", 90, 1),
                new Among("\u00EDamos", 90, 1),
                new Among("ar\u00EDamos", 95, 1),
                new Among("er\u00EDamos", 95, 1),
                new Among("ir\u00EDamos", 95, 1),
                new Among("emos", -1, 1),
                new Among("aremos", 99, 1),
                new Among("eremos", 99, 1),
                new Among("iremos", 99, 1),
                new Among("\u00E1ssemos", 99, 1),
                new Among("\u00EAssemos", 99, 1),
                new Among("\u00EDssemos", 99, 1),
                new Among("imos", -1, 1),
                new Among("armos", -1, 1),
                new Among("ermos", -1, 1),
                new Among("irmos", -1, 1),
                new Among("\u00E1mos", -1, 1),
                new Among("ar\u00E1s", -1, 1),
                new Among("er\u00E1s", -1, 1),
                new Among("ir\u00E1s", -1, 1),
                new Among("eu", -1, 1),
                new Among("iu", -1, 1),
                new Among("ou", -1, 1),
                new Among("ar\u00E1", -1, 1),
                new Among("er\u00E1", -1, 1),
                new Among("ir\u00E1", -1, 1)
            };

            a_7 = new[] 
            {
                new Among("a", -1, 1),
                new Among("i", -1, 1),
                new Among("o", -1, 1),
                new Among("os", -1, 1),
                new Among("\u00E1", -1, 1),
                new Among("\u00ED", -1, 1),
                new Among("\u00F3", -1, 1)
            };

            a_8 = new[] 
            {
                new Among("e", -1, 1),
                new Among("\u00E7", -1, 2),
                new Among("\u00E9", -1, 1),
                new Among("\u00EA", -1, 1)
            };

        }



        private bool r_prelude()
        {
            int among_var;
            while (true)
            {
                int c1 = cursor;
                bra = cursor;
                among_var = find_among(a_0);
                if (among_var == 0)
                {
                    goto lab0;
                }
                ket = cursor;
                switch (among_var) {
                    case 1:
                        slice_from("a~");
                        break;
                    case 2:
                        slice_from("o~");
                        break;
                    case 3:
                        if (cursor >= limit)
                        {
                            goto lab0;
                        }
                        cursor++;
                        break;
                }
                continue;
            lab0: ; 
                cursor = c1;
                break;
            }
            return true;
        }

        private bool r_mark_regions()
        {
            I_pV = limit;
            I_p1 = limit;
            I_p2 = limit;
            {
                int c1 = cursor;
                {
                    int c2 = cursor;
                    if (in_grouping(g_v, 97, 250, false) != 0)
                    {
                        goto lab2;
                    }
                    {
                        int c3 = cursor;
                        if (out_grouping(g_v, 97, 250, false) != 0)
                        {
                            goto lab4;
                        }
                        {

                            int ret = out_grouping(g_v, 97, 250, true);
                            if (ret < 0)
                            {
                                goto lab4;
                            }

                            cursor += ret;
                        }
                        goto lab3;
                    lab4: ; 
                        cursor = c3;
                        if (in_grouping(g_v, 97, 250, false) != 0)
                        {
                            goto lab2;
                        }
                        {

                            int ret = in_grouping(g_v, 97, 250, true);
                            if (ret < 0)
                            {
                                goto lab2;
                            }

                            cursor += ret;
                        }
                    }
                lab3: ; 
                    goto lab1;
                lab2: ; 
                    cursor = c2;
                    if (out_grouping(g_v, 97, 250, false) != 0)
                    {
                        goto lab0;
                    }
                    {
                        int c6 = cursor;
                        if (out_grouping(g_v, 97, 250, false) != 0)
                        {
                            goto lab6;
                        }
                        {

                            int ret = out_grouping(g_v, 97, 250, true);
                            if (ret < 0)
                            {
                                goto lab6;
                            }

                            cursor += ret;
                        }
                        goto lab5;
                    lab6: ; 
                        cursor = c6;
                        if (in_grouping(g_v, 97, 250, false) != 0)
                        {
                            goto lab0;
                        }
                        if (cursor >= limit)
                        {
                            goto lab0;
                        }
                        cursor++;
                    }
                lab5: ; 
                }
            lab1: ; 
                I_pV = cursor;
            lab0: ; 
                cursor = c1;
            }
            {
                int c8 = cursor;
                {

                    int ret = out_grouping(g_v, 97, 250, true);
                    if (ret < 0)
                    {
                        goto lab7;
                    }

                    cursor += ret;
                }
                {

                    int ret = in_grouping(g_v, 97, 250, true);
                    if (ret < 0)
                    {
                        goto lab7;
                    }

                    cursor += ret;
                }
                I_p1 = cursor;
                {

                    int ret = out_grouping(g_v, 97, 250, true);
                    if (ret < 0)
                    {
                        goto lab7;
                    }

                    cursor += ret;
                }
                {

                    int ret = in_grouping(g_v, 97, 250, true);
                    if (ret < 0)
                    {
                        goto lab7;
                    }

                    cursor += ret;
                }
                I_p2 = cursor;
            lab7: ; 
                cursor = c8;
            }
            return true;
        }

        private bool r_postlude()
        {
            int among_var;
            while (true)
            {
                int c1 = cursor;
                bra = cursor;
                among_var = find_among(a_1);
                if (among_var == 0)
                {
                    goto lab0;
                }
                ket = cursor;
                switch (among_var) {
                    case 1:
                        slice_from("\u00E3");
                        break;
                    case 2:
                        slice_from("\u00F5");
                        break;
                    case 3:
                        if (cursor >= limit)
                        {
                            goto lab0;
                        }
                        cursor++;
                        break;
                }
                continue;
            lab0: ; 
                cursor = c1;
                break;
            }
            return true;
        }

        private bool r_RV()
        {
            if (!(I_pV <= cursor))
            {
                return false;
            }
            return true;
        }

        private bool r_R1()
        {
            if (!(I_p1 <= cursor))
            {
                return false;
            }
            return true;
        }

        private bool r_R2()
        {
            if (!(I_p2 <= cursor))
            {
                return false;
            }
            return true;
        }

        private bool r_standard_suffix()
        {
            int among_var;
            ket = cursor;
            among_var = find_among_b(a_5);
            if (among_var == 0)
            {
                return false;
            }
            bra = cursor;
            switch (among_var) {
                case 1:
                    if (!r_R2())
                        return false;
                    slice_del();
                    break;
                case 2:
                    if (!r_R2())
                        return false;
                    slice_from("log");
                    break;
                case 3:
                    if (!r_R2())
                        return false;
                    slice_from("u");
                    break;
                case 4:
                    if (!r_R2())
                        return false;
                    slice_from("ente");
                    break;
                case 5:
                    if (!r_R1())
                        return false;
                    slice_del();
                    {
                        int c1 = limit - cursor;
                        ket = cursor;
                        among_var = find_among_b(a_2);
                        if (among_var == 0)
                        {
                            {
                                cursor = limit - c1;
                                goto lab0;
                            }
                        }
                        bra = cursor;
                        if (!r_R2())
                            {
                                cursor = limit - c1;
                                goto lab0;
                            }
                        slice_del();
                        switch (among_var) {
                            case 1:
                                ket = cursor;
                                if (!(eq_s_b("at")))
                                {
                                    {
                                        cursor = limit - c1;
                                        goto lab0;
                                    }
                                }
                                bra = cursor;
                                if (!r_R2())
                                    {
                                        cursor = limit - c1;
                                        goto lab0;
                                    }
                                slice_del();
                                break;
                        }
                    lab0: ; 
                    }
                    break;
                case 6:
                    if (!r_R2())
                        return false;
                    slice_del();
                    {
                        int c2 = limit - cursor;
                        ket = cursor;
                        if (find_among_b(a_3) == 0)
                        {
                            {
                                cursor = limit - c2;
                                goto lab1;
                            }
                        }
                        bra = cursor;
                        if (!r_R2())
                            {
                                cursor = limit - c2;
                                goto lab1;
                            }
                        slice_del();
                    lab1: ; 
                    }
                    break;
                case 7:
                    if (!r_R2())
                        return false;
                    slice_del();
                    {
                        int c3 = limit - cursor;
                        ket = cursor;
                        if (find_among_b(a_4) == 0)
                        {
                            {
                                cursor = limit - c3;
                                goto lab2;
                            }
                        }
                        bra = cursor;
                        if (!r_R2())
                            {
                                cursor = limit - c3;
                                goto lab2;
                            }
                        slice_del();
                    lab2: ; 
                    }
                    break;
                case 8:
                    if (!r_R2())
                        return false;
                    slice_del();
                    {
                        int c4 = limit - cursor;
                        ket = cursor;
                        if (!(eq_s_b("at")))
                        {
                            {
                                cursor = limit - c4;
                                goto lab3;
                            }
                        }
                        bra = cursor;
                        if (!r_R2())
                            {
                                cursor = limit - c4;
                                goto lab3;
                            }
                        slice_del();
                    lab3: ; 
                    }
                    break;
                case 9:
                    if (!r_RV())
                        return false;
                    if (!(eq_s_b("e")))
                    {
                        return false;
                    }
                    slice_from("ir");
                    break;
            }
            return true;
        }

        private bool r_verb_suffix()
        {
            if (cursor < I_pV)
            {
                return false;
            }
            int c2 = limit_backward;
            limit_backward = I_pV;
            ket = cursor;
            if (find_among_b(a_6) == 0)
            {
                {
                    limit_backward = c2;
                    return false;
                }
            }
            bra = cursor;
            slice_del();
            limit_backward = c2;
            return true;
        }

        private bool r_residual_suffix()
        {
            ket = cursor;
            if (find_among_b(a_7) == 0)
            {
                return false;
            }
            bra = cursor;
            if (!r_RV())
                return false;
            slice_del();
            return true;
        }

        private bool r_residual_form()
        {
            int among_var;
            ket = cursor;
            among_var = find_among_b(a_8);
            if (among_var == 0)
            {
                return false;
            }
            bra = cursor;
            switch (among_var) {
                case 1:
                    if (!r_RV())
                        return false;
                    slice_del();
                    ket = cursor;
                    {
                        int c1 = limit - cursor;
                        if (!(eq_s_b("u")))
                        {
                            goto lab1;
                        }
                        bra = cursor;
                        {
                            int c2 = limit - cursor;
                            if (!(eq_s_b("g")))
                            {
                                goto lab1;
                            }
                            cursor = limit - c2;
                        }
                        goto lab0;
                    lab1: ; 
                        cursor = limit - c1;
                        if (!(eq_s_b("i")))
                        {
                            return false;
                        }
                        bra = cursor;
                        {
                            int c3 = limit - cursor;
                            if (!(eq_s_b("c")))
                            {
                                return false;
                            }
                            cursor = limit - c3;
                        }
                    }
                lab0: ; 
                    if (!r_RV())
                        return false;
                    slice_del();
                    break;
                case 2:
                    slice_from("c");
                    break;
            }
            return true;
        }

        protected override bool stem()
        {
            {
                int c1 = cursor;
                r_prelude();
                cursor = c1;
            }
            r_mark_regions();
            limit_backward = cursor;
            cursor = limit;
            {
                int c3 = limit - cursor;
                {
                    int c4 = limit - cursor;
                    int c5 = limit - cursor;
                    {
                        int c6 = limit - cursor;
                        if (!r_standard_suffix())
                            goto lab4;
                        goto lab3;
                    lab4: ; 
                        cursor = limit - c6;
                        if (!r_verb_suffix())
                            goto lab2;
                    }
                lab3: ; 
                    cursor = limit - c5;
                    {
                        int c7 = limit - cursor;
                        ket = cursor;
                        if (!(eq_s_b("i")))
                        {
                            goto lab5;
                        }
                        bra = cursor;
                        {
                            int c8 = limit - cursor;
                            if (!(eq_s_b("c")))
                            {
                                goto lab5;
                            }
                            cursor = limit - c8;
                        }
                        if (!r_RV())
                            goto lab5;
                        slice_del();
                    lab5: ; 
                        cursor = limit - c7;
                    }
                    goto lab1;
                lab2: ; 
                    cursor = limit - c4;
                    if (!r_residual_suffix())
                        goto lab0;
                }
            lab1: ; 
            lab0: ; 
                cursor = limit - c3;
            }
            {
                int c9 = limit - cursor;
                r_residual_form();
                cursor = limit - c9;
            }
            cursor = limit_backward;
            {
                int c10 = cursor;
                r_postlude();
                cursor = c10;
            }
            return true;
        }

    }
}

